	include	"FLIB.H"
	include	"GRAY4LIB.H"
	include	"HEXLIB.H"
	include	"KERNEL.H"
	include	"TIOS.H"
	include	"MACROS.H"
	xdef	_main
	xdef	_comment

_main:
         move.l #0,POINT  
         lea AITab(PC),a0
         move.l a0,AIPoint
	pea		filename(PC)
	move.w		#$C,-(sp)
	jsr		tios::FindSymEntry
	addq.l		#6,sp
	cmp.l		#0,a0
	beq		Done	;Couldn't find configuration variable!
        move.w  tios::SYM_ENTRY.hVal(a0),d0     ;handle of the file
        tios::DEREF d0,a3           ;address of the file
        move.w  (a3),d0                         ;size of the file
        move.b  1(a3,d0.w),d1                   ;get data type
        cmp.b   #$E0,d1                         ;is text?
        bne Done
        add #6,a3
        move.l a3,POINT
         move.w #0,debg  
         move.b #0,moove  
         move.w #0,spice  
         move.w #0,time
         move.w #8,ral
         move.w #1,money
         move.w #10,mc
         move.w #6,mx
         move.w #3,my
         move.w #5,Al
         move.w #4,En
                            clr.l           d0
                          lea unit(PC),a0
                          move.l a0,UnPOS
                          add #60,a0
                          move.l a0,UnDES
                          add #60,a0
                          move.l a0,UnLAT
                          add #60,a0
                          move.l a0,UnTRA1
                          add #60,a0
                          move.l a0,UnTRA2
                          add #60,a0
                          move.l a0,UnTRA3

                          lea TABAl(PC),a1
                          lea TABEn(PC),a3
                          move.l UnPOS,a0

                          move.w #3,d0    ; BATIMENT ALLIE
                          lsl #8,d0
                          add #4,d0
                          move.w d0,(a0)
                          move.w #0,(a1)
                          add #2,a1
                          add #2,a0
                          move.w #4,d0
                          lsl #8,d0
                          add #4,d0
                          move.w d0,(a0)
                          move.w #1,(a1)
                          add #2,a1
                          add #2,a0
                          move.w #3,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)
                          move.w #2,(a1)
                          add #2,a1
                          add #2,a0
                          move.w #4,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)   ; 
                          add #2,a0
                          move.w #3,(a1)
                          add #2,a1

                          move.w #11,d0    ; Batiment Ennemi
                          lsl #8,d0
                          add #27,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #4,(a3)
                          add #2,a3
                          move.w #12,d0
                          lsl #8,d0
                          add #27,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #5,(a3)
                          add #2,a3
                          move.w #11,d0
                          lsl #8,d0
                          add #28,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #6,(a3)
                          add #2,a3
                          move.w #12,d0
                          lsl #8,d0
                          add #28,d0
                          move.w d0,(a0)
                          add #2,a0        ;
                          move.w #7,(a3)
                          add #2,a3
                          
                          move.w #6,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #8,(a1)
                          add #2,a1
                          move.w #3,d0
                          lsl #8,d0
                          add #10,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #9,(a1)
                          add #2,a1
                          move.w #6,d0
                          lsl #8,d0
                          add #11,d0
                          move.w d0,(a0)
                          move.w #10,(a3)

                            clr.l           d1
                          move.l UnDES,a0
                          move.w #3,d0
                          lsl #8,d0
                          add #4,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #4,d0
                          lsl #8,d0
                          add #4,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #3,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #4,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)
                          add #2,a0

                          move.w #11,d0
                          lsl #8,d0
                          add #27,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #12,d0
                          lsl #8,d0
                          add #27,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #11,d0
                          lsl #8,d0
                          add #28,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #12,d0
                          lsl #8,d0
                          add #28,d0
                          move.w d0,(a0)
                          add #2,a0
                          

                          move.w #6,d0
                          lsl #8,d0
                          add #5,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #3,d0
                          lsl #8,d0
                          add #10,d0
                          move.w d0,(a0)
                          add #2,a0
                          move.w #6,d0
                          lsl #8,d0
                          add #11,d0
                          move.w d0,(a0)

                          move.l UnLAT,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #8,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #8,d0
                          move.w #2,d2
                          lsl #8,d2
                          lsl #6,d2
                          add.w d2,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #8,d0
                          move.w #1,d2
                          lsl #8,d2
                          lsl #6,d2
                          add d2,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #8,d0
                          move.w #3,d2
                          lsl #8,d2
                          lsl #6,d2
                          add.w d2,d0
                          move.w d0,(a2)
                          add.w #2,a2

                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #24,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #24,d0
                          move.w #2,d2
                          lsl #8,d2
                          lsl #6,d2
                          add d2,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #24,d0
                          move.w #1,d2
                          lsl #8,d2
                          lsl #6,d2
                          add d2,d0
                          move.w d0,(a2)
                          add.w #2,a2
                          move.w #1,d0
                          lsl #8,d0
                          lsl #3,d0
                          add #24,d0
                          move.w #3,d2
                          lsl #8,d2
                          lsl #6,d2
                          add d2,d0
                          move.w d0,(a2)
                          add.w #2,a2

                          move #3,d0
                          lsl #6,d0
                          add #7,d0
                          lsl #8,d0
                          add #3,d0
                          move.w d0,(a2)
                          add #2,a2
                          move #3,d0
                          lsl #6,d0
                          add #7,d0
                          lsl #8,d0
                          add #4,d0
                          move.w d0,(a2)
                          add #2,a2
                          move #1,d0
                          lsl #6,d0
                          add #9,d0
                          lsl #8,d0
                          add #22,d0
                          move.w d0,(a2)

                          clr.l d0
                          move.l d0,a2
                          move #10,UnNB                                  


                           jsr flib::clr_scr
 move.l         #1514,-(a7)
 jsr            tios::HeapAlloc
 lea             4(a7),a7
 move.w         d0,hnbr
 tios::DEREF     d0,a0
 move.l         a0,haddr

        jsr gray4lib::on
        move.l  gray4lib::plane0,greyplane
        bsr ClearScr 
;-------------------------------------------------------- Decompressage------------------- 
         clr.l d0
         clr.l d1
         clr.l d2
         clr.l d4
         clr.l d6
         clr.l d3
         clr.l d5
         move #14,d6
         move #93,d7
         move.l haddr,a5
;         move.l a5,d4
;         move.l d4,haddr
         lea spirit(PC),a3
         clr.l d3
         clr.l d2

forx:
         move.l (a3),d1
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
          lsr d6,d1          
          lsl d6,d1 ; But : Enlever le premier bit trouv de sa place (2^14)
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1 ; Dcalage de 2^12
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
         lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1 ; Dcalage de 2^12
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
          lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
          lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
          lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
          lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         move.l (a3),d1
         lsr d6,d1
          lsl d6,d1
         move.l (a3),d0
         sub d1,d0
         move.l d0,d1
         sub #2,d6
         lsr d6,d1
         move.w d1,(a5)
         add #2,a5
         clr.l d1
         move #14,d6
         add #2,a3

 dbeq d7,forx
; -----------------------Fin du decompressage------------------------------------------------
; --------- Debut de l'affichage de l'ecran ---------------------------------------------------

;---- Affichage du plan ?
Affich:
 move #192,d0
 move #0,d1
 move #45,d2
 bsr PutSprite
 move #208,d0
 move #0,d1
 move #51,d2
 bsr PutSprite
 move #224,d0
 move #0,d1
 move #46,d2
 bsr PutSprite
 move #192,d0
 move #96,d1
 move #47,d2
 bsr PutSprite
 move #208,d0
 move #96,d1
 move #52,d2
 bsr PutSprite
 move #224,d0
 move #96,d1
 move #48,d2
 bsr PutSprite
 move #224,d0
 move #16,d1
 move #50,d2
 bsr PutSprite
 move #224,d0
 move #32,d1
 move #50,d2
 bsr PutSprite
 move #224,d0
 move #48,d1
 move #50,d2
 bsr PutSprite
 move #224,d0
 move #64,d1
 move #54,d2
 bsr PutSprite
 move #224,d0
 move #80,d1
 move #50,d2
 bsr PutSprite
 move #192,d0
 move #16,d1
 move #49,d2
 bsr PutSprite
 move #192,d0
 move #32,d1
 move #49,d2
 bsr PutSprite
 move #192,d0
 move #48,d1
 move #49,d2
 bsr PutSprite
 move #192,d0
 move #64,d1
 move #53,d2
 bsr PutSprite
 move #192,d0
 move #80,d1
 move #49,d2
 bsr PutSprite
 move #208,d0
 move #64,d1
 move #52,d2
 bsr PutSprite
 move #200,d0
 move #8,d1
 move #55,d2
 bsr PutSprite
 move #200,d0
 move #48,d1
 move #60,d2
 bsr PutSprite
 move #200,d0
 move #32,d1
 move #60,d2
 bsr PutSprite
 move #216,d0
 move #48,d1
 move #60,d2
 bsr PutSprite
 move #216,d0
 move #32,d1
 move #60,d2
 bsr PutSprite
 move #216,d0
 move #8,d1
 move #56,d2
 bsr PutSprite

 move.l haddr,a5
 clr.l d5
 clr.l d6

 move d5,x
 move d6,y
 clr.l d5
 clr.l d6
 move #755,d7
forplan:
 move d7,i
 add #1,x
 cmp #36,x
 bne Em
 clr.l d5
 move d5,x
 add #1,y

Em:	

 move x,d0  
 move y,d1
 add #198,d0  
 add #83,d1  
 move.w (a5),d3
 lsl #8,d3
 lsr #8,d3
 cmp #3,d3
 bne Emm
 move #259,d3
 move.w d3,(a5) 
 move #3,d3
 
Emm:
 bsr put_grayscale_pixel
 move i,d7
 add #2,a5
 dbeq d7,forplan
         SetFont #2
         WriteStr #0,#114,#4,argent

;**********************************************************
;*                                   Peace of Earth : Let my program go !!!                             *
;**********************************************************


  clr.l d1 
   clr.l d0 
   clr.l d3
   clr.l d2 
   clr.l d6
   clr.l d5
   clr.l d7
   move.w UnNB,d7
   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   move.l haddr,a6
   move.l a6,d6
   sub #8,d7
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6
   move #6,d0
   move #0,d4
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT

   add #8,a3
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6


   move #4,d4
   move #7,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT

   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   add #16,a3
   add #16,a2
   add #16,a4
fD:
   move.w (a4),d2   
   move.l d2,d5
   lsl #8,d2
   lsl #5,d2
   lsr #8,d2
   lsr #5,d2
   cmp #3,d2
   bne tour   
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   bra FinfD

tour:
   cmp #2,d2
   bne Autr   
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #148,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #4,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT

   bra FinfD  

Autr:
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #146,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #66,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #4,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #66,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT


FinfD:
   add #2,a3
   add #2,a4
   add #2,a2
 dbra d7,fD


Main:
       jsr AI
;-----------------------------------------------!Dbut of Units Movement
;                                               _-------------__                                                                                     TWUCE MEN
;                                          o0O /   Ouah Classe  \                                                                                               !!!
;                                        o      \_______________/         				            PEACE
;----------------------------------------------!  DEBUT DE UNTIES MOVEMENT

   move UnNB,d7
   move.l UnPOS,a3
   move.l UnDES,a4
   move.l UnLAT,a5
   move.l UnTRA1,a0
   move.l UnTRA2,a1
   move.l UnTRA3,a2
 
forD:
   move.l haddr,a6
   move.w (a3),d3
   move.w (a4),d4
   cmp d3,d4    
   beq Finde 

   move.l (a1),(a2)    ; Sauvegarde de la traine
   move.l (a0),(a1)
   move.l (a3),(a0)

   move.w (a2),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move #1,d3
   lsl #8,d3
   add d3,d2
   move.w d2,(a6) 
   move.l haddr,a6


   move.w (a1),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move #1,d3
   lsl #8,d3
   add d3,d2
   move.w d2,(a6) 
   move.l haddr,a6
  
   move.w (a0),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move #1,d3
   lsl #8,d3
   add d3,d2
   move.w d2,(a6) 
   move.l haddr,a6

   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X               ;
   lsr #8,d0 ; Usueal

   move.w (a5),d5
   lsl #2,d5
   lsr #2,d5
   lsr #8,d5
   lsr #5,d5
   cmp #1,d5
   beq Yprio
   bne Xprio
   
Yprio:
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   move.w (a4),d4
   move.l d4,d1
   lsr #8,d1
   cmp d1,d3
   bgt TYM
   blt TYP
   beq YEQ

TYP: 
   add #1,d3
   jsr Occup
   sub #1,d3
   cmp #1,d2
   bne TYPS
   sub #1,d0
   jsr Occup
   add #1,d0
   cmp #1,d2
   beq TYP1
   bne TYP2

TYP1:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   lsl #8,d2
   lsl #4,d2
   add d2,d4
   move.w d4,(a5)

TYP2:
   add #1,d0
   jsr Occup
   sub #1,d0
   cmp #1,d2
   beq TYP3
   bne TYP4

TYP3:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   move.w d4,(a5)

TYP4:
   add #1,d0
   jsr Occup
   sub #1,d0
   cmp #1,d2
   bne TYP5
   sub #1,d0
   jsr Occup
   add #1,d0
   cmp #1,d2
   bne TYP5
   beq YM

TYP5:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   cmp #1,d5
   beq TXP
   bne TXM      

TYPS:
   bra YP

TYM:
   sub #1,d3
   jsr Occup
   add #1,d3
   cmp #1,d2
   bne TYMS
   sub #1,d0
   jsr Occup
   add #1,d0
   cmp #1,d2
   beq TYM1
   bne TYM2

TYM1:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   lsl #8,d2
   lsl #4,d2
   add d2,d4
   move.w d4,(a5)

TYM2:
   add #1,d0
   jsr Occup
   sub #1,d0
   cmp #1,d2
   beq TYM3
   bne TYM4

TYM3:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   move.w d4,(a5)

TYM4:
   add #1,d0
   jsr Occup
   sub #1,d0
   cmp #1,d2
   bne TYM5
   sub #1,d0
   jsr Occup
   add #1,d0
   bne TYM5
   beq YP

TYM5:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   cmp #1,d5
   beq TXP
   bne TXM      

TYMS:
   bra YM

 
YEQ:
   move.w (a5),d5
   move.l d5,d2
   lsl #3,d5
   lsr #3,d5
   lsr #8,d2
   lsr #6,d2
   lsl #8,d2

   lsl #6,d2
   add d2,d5
   move.w d5,(a5)

Xprio:
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   move.w (a4),d4
   move.l d4,d1
   lsl #8,d1
   lsr #8,d1
   cmp d1,d0
   bgt TXM
   blt TXP
   beq XEQ

TXP: 
   add #1,d0
   jsr Occup
   sub #1,d0
   cmp #1,d2
   bne TXPS
   add #1,d3
   jsr Occup
   sub #1,d3
   cmp #1,d2
   beq TXP1
   bne TXP2

TXP1:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   lsl #8,d2
   lsl #4,d2
   add d2,d4
   move.w d4,(a5)

TXP2:
   sub #1,d3
   jsr Occup
   add #1,d3
   cmp #1,d2
   beq TXP3
   bne TXP4

TXP3:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   move.w d4,(a5)

TXP4:
   add #1,d3
   jsr Occup
   sub #1,d3
   cmp #1,d2
   bne TXP5
   sub #1,d3
   jsr Occup
   add #1,d3
   cmp #1,d2
   bne TXP5
   beq XM

TXP5:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   cmp #1,d5
   beq TYM
   bne TYP      

TXPS:
   bra XP

TXM:
   sub #1,d0
   jsr Occup
   add #1,d0
   cmp #1,d2
   bne TXMS
   add #1,d3
   jsr Occup
   sub #1,d3
   cmp #1,d2
   beq TXM1
   bne TXM2

TXM1:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   lsl #8,d2
   lsl #4,d2
   add d2,d4
   move.w d4,(a5)

TXM2:
   sub #1,d3
   jsr Occup
   add #1,d3
   cmp #1,d2
   beq TXM3
   bne TXM4

TXM3:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   lsl #8,d5
   lsl #4,d5
   sub d5,d4
   move.w d4,(a5)

TXM4:
   add #1,d3
   jsr Occup
   sub #1,d3
   cmp #1,d2
   bne TXM5
   sub #1,d3
   jsr Occup
   add #1,d3
   cmp #1,d2
   bne TXM5
   beq XP

TXM5:
   move.w (a5),d5
   move.l d5,d4
   lsl #3,d5
   lsr #3,d5
   lsr #8,d5
   lsr #4,d5
   cmp #1,d5
   beq TYM
   bne TYP      

TXMS:
   bra XM

XEQ:
   move.w (a5),d5
   move.l d5,d2
   lsl #3,d5
   lsr #3,d5
   lsr #8,d2
   lsr #6,d2
   lsl #8,d2
   lsl #6,d2
   add d2,d5
   move #1,d2
   lsl #8,d2
   lsl #5,d2
   add d2,d5
   move.w d5,(a5)
   bra Yprio   

YP:
   add #1,d3
   lsl #8,d3   
   add d0,d3
   move.w d3,(a3)
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   sub #1,d3
   jsr Getdecal
   sub #146,a6
   move #7,d0
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #212,a6
   jsr SetTAB

   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3


   move.w (a5),d5
   lsl #2,d5
   lsr #2,d5
   move #3,d6
   lsl #8,d6
   lsl #6,d6
   add d6,d5
   move.w d5,(a5)
   
   bra Finde

XM:
   sub #1,d0
   lsl #8,d3   
   add d0,d3
   move.w d3,(a3)
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   add #1,d0
   jsr Getdecal
   sub #142,a6
   move #7,d0
   jsr SetTAB
   add #72,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #4,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #70,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #70,a6
   jsr SetTAB

   move.w (a5),d5
   lsl #2,d5
   lsr #2,d5
   move.w d5,(a5)
   bra Finde

YM:
   sub #1,d3
   lsl #8,d3   
   add d0,d3
   move.w d3,(a3)
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   add #1,d3
   jsr Getdecal
   sub #72,a6
   move #7,d0
   jsr SetTAB
   add #140,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB

   move.w (a5),d5
   lsl #2,d5
   lsr #2,d5
   move #1,d6
   lsl #8,d6
   lsl #6,d6
   add d6,d5
   move.w d5,(a5)

   bra Finde

XP:
   add #1,d0
   lsl #8,d3   
   add d0,d3
   move.w d3,(a3)
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   sub #1,d0
   jsr Getdecal
   sub #146,a6
   move #7,d0
   jsr SetTAB
   add #70,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #70,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #4,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #72,a6
   jsr SetTAB

   move.w (a5),d5
   lsl #2,d5
   lsr #2,d5
   move #2,d6
   lsl #8,d6
   lsl #6,d6
   add d6,d5
   move.w d5,(a5)

   bra Finde

Finde:

   move.l haddr,a6

   move.w (a2),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y         
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move.w d2,(a6) 
   move.w (a1),d3
   move.l d3,d0
   lsr #8,d3  
   lsl #8,d0  
   lsr #8,d0 
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move.w d2,(a6)
   move.l haddr,a6
   move.w (a0),d3
   move.l d3,d0
   lsr #8,d3 
   lsl #8,d0  
   lsr #8,d0 
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move.w d2,(a6) 
   move.l haddr,a6 

   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
            move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   lsl #8,d3
   lsl #1,d3
   lsl #8,d2
   lsr #8,d2
   add d3,d2
   move #1,d3
   lsl #8,d3
   add d3,d2
   move.w d2,(a6) 
   add #2,a3
   add #2,a4
   add #2,a5
   add #2,a0
   add #2,a1
   add #2,a2

  dbra d7,forD


;---------------------------------- A la mmoire de SanFrancisco -------

  move.l haddr,a5
  move mapy,d1
  move.l d1,d0
  lsl #5,d1        ; pos in memory = y*36 (y*32+y*4 or y shl 5 + y shl 2) + x
  lsl #2,d0
  add d0,d1
  lsl #1,d1   ; *2 because of word>longint
  move mapx,d0
  lsl #1,d0  ; same thing
  add d0,d1
  add d1,a5
  
  clr.l d1
  clr.l d0
  clr.l d3
  clr.l d2
  clr.l d5

  move d5,x 
  move d5,y
  move #6,d7
for1:
  clr.l d0
  move d0,x
  move #11,d6

for2:

  move x,d0
  move y,d1 

  move.w (a5),d3
  add #2,a5
  move.l d3,d4

    cmp #1,debg
    bne NormalM
  lsr #8,d3
  lsr #6,d3

NormalM:
  lsl #7,d4
  lsr #7,d4
  lsr #8,d4
  tst.w d4
  bne Fincse 
  lsl #8,d3       ;     But : Virer la protection anti unit (normalement  0)
  lsr #8,d3

  cmp #2,d3
  beq DrawTar
  cmp #1,d3
  beq DrawSpice
  cmp #0,d3
  beq DrawSand
  bne Fincse
DrawTar:
    move #4,d2
    bsr PutSprite
    bra Fincse
DrawSpice:
    move #5,d2
    bsr PutSprite
    bra Fincse
DrawSand:
    cmp.b #1,moove
    beq DrawMoove
    move #0,d2
    bsr PutSprite
    bra Fincse
    
DrawMoove:  
    move #4,d0
    jsr flib::random
    move #0,d2
    add d0,d2
    move x,d0
    bsr PutSprite
    bra Fincse

Fincse:  
    

    add #16,d0
    move d0,x
 dbra d6,for2

  
   add #16,d1
   move d1,y
   add #48,a5
 

 dbra d7,for1


;---------------------------------- A la mmoire de SanFrancisco -------
   clr.l d1 
   clr.l d0 
   clr.l d3
   clr.l d2 
   clr.l d6
   clr.l d5
   clr.l d7
   move.w UnNB,d7
   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   move #0,ms
 
forU:
   move.w (a3),d3
   move.l d3,d0
   lsl #8,d0
   lsr #8,d0
   cmp mapx,d0
   blt Ended
   sub #11,d0
   cmp mapx,d0
   bgt Ended
   add #11,d0
   sub mapx,d0
   lsr #8,d3
   move d3,d1
   cmp mapy,d1
   blt Ended
   sub #6,d1
   cmp mapy,d1
   bgt Ended
   add #6,d1
   sub mapy,d1

   move.w (a4),d6
   lsl #8,d6
   lsl #4,d6
   lsr #4,d6
   lsr #8,d6
   cmp #8,d6
   beq Bat

   cmp mx,d0
   bne Etape
   cmp my,d1
   bne Etape
   move UnNB,d2
   sub d7,d2
   move d2,ms
   add #1,ms
   move #57,mc         
   lsl #4,d0
   lsl #4,d1
   
   move.w (a4),d6
   move.l d6,d2
   lsr #8,d6
   lsr #6,d6      
   lsl #8,d2  ; We require D2, D1 and D0 to be byte
   lsl #5,d2
   lsr #5,d2
   lsr #8,d2  ; Awful program ?
   cmp #3,d2
   bne SourEtp
   move.w (a4),d5
   move.l d5,d4
   lsl #8,d4
   lsl #2,d4
   lsr #8,d4
   lsr #7,d4
   cmp #1,d4
   bne SourEtp
   move.w time,d4
   lsr.w #2,d4
   lsl.w #2,d4
   cmp time,d4
   bne TESTT2
   move.l d5,d4
   lsl #8,d4
   lsr #8,d4
   lsr #6,d4
   lsl #6,d4
   sub d4,d5
   lsr #6,d4
   add #1,d4
   lsl #6,d4
   add d4,d5
   move.w d5,(a4)
   bra TESTT2
   
TESTT2:
   move #59,d2
   bsr PutSprite
   bra Ended 
   
SourEtp:
   lsl #2,d2
   add #12,d2
   add d6,d2
   bsr PutSprite   
   bra Ended

Etape:
   lsl #4,d0
   lsl #4,d1
   move.w (a4),d2
   move.l d2,d6
   lsl #8,d2
   lsl #5,d2
   lsr #8,d2
   lsr #5,d2
   cmp #3,d2
   bne Sut
   move.l d6,d2
   lsl #8,d2
   lsl #2,d2
   lsr #8,d2
   lsr #7,d2
   cmp #1,d2
   bne Sut
   move.w (a3),d2
   move.w (a2),d4
   cmp.w d2,d4
   bne Sut
   move.w time,d2
   lsr.w #2,d2
   lsl.w #2,d2
   cmp time,d2
   bne TESTT
   move.l d6,d2
   lsl #8,d2
   lsr #8,d2
   lsr #6,d2
   lsl #6,d2
   sub d2,d6
   lsr #6,d2
   add #1,d2
   lsl #6,d2
   add d2,d6
   move.w d6,(a4)
   bra TESTT
  
TESTT:
   move #59,d2
   bsr PutSprite
   bra Ended 

Sut:   
   move.w (a4),d6
   move.l d6,d2
   lsr #8,d6
   lsr #6,d6      
   lsl #8,d2  ; We require D2, D1 and D0 to be byte
   lsl #5,d2
   lsr #5,d2
   lsr #8,d2  ; Awful program ?
   lsl #2,d2
   add #12,d2
   add d6,d2
   bsr PutSprite2   
   bra Ended

Bat:
   cmp mx,d0
   bne BatSu
   cmp my,d1
   bne BatSu
   move.w (a4),d6
   move.l d6,d2
   lsl #8,d2
   lsl #3,d2
   lsr #8,d2
   lsr #7,d2
   move #256,ms
   add d2,ms   

BatSu:
   lsl #4,d0
   lsl #4,d1
   move.w (a4),d6
   move.l d6,d2
   lsr #8,d6
   lsr #6,d6      
   move.w #6,d2
   add.w d6,d2
   bsr PutSprite

Ended:
   add.w #2,a3
   add.w #2,a4
   add.w #2,a2


 dbra d7,forU

;--------------------------------------- Souris? Souris-nous !-----------------------------
 move mx,d0
 move my,d1
 lsl #4,d0
 lsl #4,d1
 cmp #0,select
 bgt SourisCib
 cmp #10,mc
 bne SourisSuite
  move mc,d2
  bsr PutSprite2   
  bra SourisSuite
SourisCib:
   cmp #3,select 
   bne SourSui 
  move.l haddr,a5
  move mapy,d1
  add my,d1
  move.l d1,d0
  lsl #5,d1       
  lsl #2,d0
  add d0,d1
  lsl #1,d1   
  move mapx,d0
  add mx,d0
  lsl #1,d0  
  add d0,d1
  add d1,a5
  move #44,mc
  move.w (a5),d5
  lsl #8,d5
  lsr #8,d5
   cmp #1,d5  
  beq SourisCis
  move #35,mc

SourSui:
  move #35,mc
  move.l UnLAT,a4
  move.w ms,d5
  cmp #0,ms 
  beq SourisCis
  move #44,mc
  cmp #257,ms
  beq SourisCis
  sub #1,d5
  lsl #1,d5
  add d5,a4 
  move.w (a4),d4
  lsl #8,d4
  lsl #3,d4
  lsr #7,d4
  lsr #8,d4
  cmp #1,d4
  beq SourisCis
  move #35,mc

SourisCis:  
  move mx,d0 
  move my,d1
  lsl #4,d0
  lsl #4,d1
  move mc,d2
  bsr PutSprite2   

SourisSuite:
;------------------------------------------------------------------------------------------------ 
;           Ici on gre les fonctions des units 
;------------------------------------------------------------------------------------------------ 

  clr.l d1 
   clr.l d0 
   clr.l d3
   clr.l d2 
   clr.l d6
   clr.l d5
   clr.l d7
   move.w UnNB,d7
   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   move.l haddr,a6
   sub #8,d7
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6
   move #6,d0
   move #0,d4
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT

   add #8,a3
   move.w (a3),d3
   move.l d3,d0
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6
   move #4,d4
   move #7,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT

   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   add #16,a3
   add #16,a2
   add #16,a4
FORD:
   clr.l d3
   clr.l d1
   clr.l d0
   move.w (a4),d2   
   move.l d2,d5
   lsl #8,d2
   lsl #5,d2
   lsr #8,d2
   lsr #5,d2
   cmp #3,d2
   bne FORtour   

   move.l d5,d2   ; Special ?
   lsl #8,d2
   lsl #2,d2
   lsr #8,d2
   lsr #7,d2
   cmp #1,d2
   bne STV

   move.l d5,d2   ; Contenance ?
   lsl #8,d2
   lsr #8,d2
   lsr #6,d2
   cmp #3,d2       ; Pleine ?
   bne STN

   move.l d5,d2  ; Y a plus special
   lsl #8,d2
   lsl #2,d2
   lsr #8,d2
   lsr #7,d2
   lsl #5,d2
   sub d2,d5
   move.w d5,(a4)


   move.l UnPOS,a1
   add #2,a1
   move.w (a1),d2
   add #256,d2
   move.w d2,(a2)
   bra STN

STV:
   move.l d5,d2   ; Contenance ?
   lsl #8,d2
   lsr #8,d2
   lsr #6,d2
   cmp #3,d2
   bne STN
   move.l UnPOS,a1
   add #2,a1
   move.w (a1),d2
   add #256,d2
   move.w (a3),d3
   cmp d2,d3
   bne STN
   move.w time,d2
   lsr.w #4,d2
   lsl.w #4,d2
   cmp time,d2
   bne STN
   move.l haddr,a5
   move.w spice,d3
   lsl #2,d3
   lsr #2,d3
   lsr #8,d3
   move.l d3,d4
   lsl #5,d3       
   lsl #2,d4
   add d4,d3
   lsl #1,d3   
   move.w spice,d4
   lsl #2,d4
   lsr #2,d4
   lsl #8,d4
   lsr #7,d4
   add d4,d3
   add d3,a5
   move #0,(a5)
   sub #192,d5
   add #20,money
   move.w d5,(a4)
   jsr GetNP
   tst.w spice
   beq STN
   move.w spice,d4
   lsl #2,d4
   lsr #2,d4
   move.w d4,(a2)
    move.w (a4),d4
    move.l d4,d5
    lsl #8,d5
    lsl #2,d5
    lsr #8,d5
    lsr #7,d5
    lsl #5,d5
    sub d5,d4
    move #1,d5
    lsl #5,d5
    add d5,d4
    move.w d4,(a4)    

STN:
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #74,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   add #72,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #2,a6
   jsr SetBAT
   sub #72,a6
   jsr SetBAT
   bra FinFORD

FORtour:
   cmp #2,d2
   bne FORAutr   
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #148,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #4,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT

   bra FinFORD  

FORAutr:
   move.w (a3),d3
   move.l d3,d0   
   lsr #8,d3  ; d3=Y
   lsl #8,d0  ; d0=X
   lsr #8,d0 ; Usueal
   jsr Getdecal
   sub #146,a6
   move UnNB,d4
   sub d7,d4
   move.l d5,d0
   lsl #8,d0
   lsl #3,d0
   lsr #8,d0
   lsr #7,d0
   add #6,d0
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #66,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #4,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #64,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #66,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT
   add #2,a6
   jsr SetBAT


FinFORD:
   add #2,a3
   add #2,a4
   add #2,a2
 dbra d7,FORD

  clr.l d1 
   clr.l d0 
   clr.l d3
   clr.l d2 
   clr.l d6
   clr.l d5
   clr.l d7
   clr.w x
   move.w UnNB,d7
   move.l UnPOS,a3
   move.l UnDES,a2
   move.l UnLAT,a4
   move.l haddr,a6
   add #16,a3
   add #16,a2
   add #16,a4
   sub #8,d7
forTEST:
   move.w (a3),d3
   move.l d3,d0
   lsl #8,d0
   lsr #8,d0
   lsr #8,d3
   jsr Getdecal
   move.w (a6),d2
   move.l d2,d4
   lsr #8,d4
   lsr #6,d4
   cmp #3,d4
   beq FindEn
   cmp #0,d4
   beq EndforTEST
   lsr #1,d4   ; 1 si En 0 si Al
   move.w (a4),d3
   lsl #8,d3
   lsl #3,d3
   lsr #8,d3
   lsr #7,d3
   cmp d4,d3
   beq EndforTEST
   move.l d2,d4
   lsl #2,d4   ; Put position sur le Nb unit
   lsr #3,d4   
   lsr #8,d4   
   lsl #1,d4  ; *2
   cmp #0,d4
   beq FindEn
   move.w (a3),d0
   move.l UnPOS,a5
   add d4,a5
   move.w (a5),d1
   move.l d4,-(a7)
   jsr TIR
   move.l (a7)+,d4
   move.l d4,d3
   bra FindTIR
   
   bra EndforTEST 

FindEn:
   move.w (a4),d3
   lsl #8,d3
   lsl #3,d3
   lsr #8,d3
   lsr #7,d3
   cmp #0,d3
   bne FndEnne
   lea TABEn(PC),a0
   move.w En,d6
forAllie:
   move.l UnPOS,a1
   move.w (a0),d3
   lsl #1,d3
   add d3,a1
   move.w (a1),d0
   move.w (a3),d4
   move.l d0,d1   
   move.l d4,d5   
   lsl #8,d0
   lsr #8,d0
   lsr #8,d1
   lsl #8,d4
   lsr #8,d4
   lsr #8,d5
   sub d4,d0
   cmp #0,d0
   bgt fAX
   neg d0 
fAX:
   sub d5,d1
   cmp #0,d1
   bgt fAY
   neg d1
fAY:
   mulu.w d0,d0 
   mulu.w d1,d1 
   add d0,d1
   cmp #8,d1    ; Est ce que cette unit est prs ?
   bgt EndAllie
   move.w (a3),d0
   move.w (a1),d1
   jsr TIR
   move.w (a0),d3
   lsl #1,d3
   lea TABEn(PC),a6
   bra FindTIR

   
EndAllie:
  add #2,a0
  add #1,x
 dbra d6,forAllie

FndEnne:
   lea TABAl(PC),a0
   move.w Al,d6
forEnne:
   move.l UnPOS,a1
   move.w (a0),d3
   lsl #1,d3
   add d3,a1
   move.w (a1),d0
   move.w (a3),d4
   move.l d0,d1   
   move.l d4,d5   
   lsl #8,d0
   lsr #8,d0
   lsr #8,d1
   lsl #8,d4
   lsr #8,d4
   lsr #8,d5
   sub d4,d0
   cmp #0,d0
   bgt fEX
   neg d0 
fEX:
   sub d5,d1
   cmp #0,d1
   bgt fEY
   neg d1
fEY:
   mulu.w d0,d0 
   mulu.w d1,d1 
   add d0,d1
   cmp #8,d1
   bgt EndEnne
   move.w (a3),d0
   move.w (a1),d1
   jsr TIR
   move.w (a0),d3
   lsl #1,d3
   lea TABAl(PC),a6
   bra FindTIR

   
EndEnne:
  add #2,a0
  add #1,x
 dbra d6,forEnne
   bra EndforTEST


FindTIR:
   move.l UnLAT,a1
   move.l d3,d5
   add d3,a1
   move.w (a1),d3
   move.l d3,d4
   lsl #4,d4
   lsr #8,d4
   lsr #4,d4
   move.l d4,d2
   lsl #8,d4
   sub d4,d3
   cmp #1,d2
   bne UnDMG
   move.l UnPOS,a1
   move.l d5,d4
   add d5,a1
   move.w (a1),d0
   move.l d0,d1
   lsl #8,d0
   lsr #8,d0
   lsr #8,d1
   move.l d0,d5
   move.l d1,d3
   jsr Getdecal
   move.w #0,(a6)  ; Destruct Unit print on floor
   sub #146,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #64,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #4,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #64,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #66,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB
   add #2,a6
   jsr SetTAB

   move.l d5,d0
   cmp mapx,d0
   blt Explo
   sub #11,d0
   cmp mapx,d0
   bgt Explo
   add #11,d0
   sub mapx,d0
   cmp mapy,d1
   blt Explo
   sub #6,d1
   cmp mapy,d1
   bgt Explo
   add #6,d1
   sub mapy,d1
   lsl #4,d0
   lsl #4,d1
   move #58,d2
   jsr PutSprite
   move #2,d1
   jsr Delay
       
Explo:
   move.l d4,d5
   move.l UnPOS,a1
   move.l UnDES,a0
   move.l UnLAT,a5
   sub #1,UnNB
   move.w UnNB,d0
   add d5,a5
   move.w (a5),y
   move.l d5,d4
   add #2,d5
   add d5,a1
   add d5,a0
   add #2,a5
forUND:
   move.w (a1),d1
   move.w (a0),d2
   move.w (a5),d3
   sub #2,a1
   sub #2,a0
   sub #2,a5
   move.w d1,(a1)
   move.w d2,(a0)
   move.w d3,(a5)
   add #4,a1
   add #4,a0
   add #4,a5

 dbra d0,forUND
   move.w y,d1
   lsl #8,d1
   lsl #3,d1
   lsr #8,d1
   lsr #7,d1
   cmp #0,d1
   beq frTABAl

frTABEn:   
   sub #1,En
   move En,d0
   lea TABEn(PC),a6
   move x,d2
   lsl #1,d2
   add d2,a6
   add #2,a6
forTABEn:
   move.w (a6),d3
   sub #2,a6
   move.w d3,(a6)
   add #4,a6
  dbra d0,forTABEn

   move Al,d0
   lea TABAl(PC),a6
   lsr #1,d4
forTABEnA:
   move.w (a6),d3
   cmp d4,d3
   blt ENA
   sub #1,d3
   move.w d3,(a6)
ENA:   
   add #2,a6
  dbra d0,forTABEnA
   
   bra EndforTEST


frTABAl:
   sub #1,Al
   move Al,d0
   lea TABAl(PC),a6
   move x,d2
   lsl #1,d2
   add d2,a6
   add #2,a6
forTABAl:
   move.w (a6),d3
   sub #2,a6
   move.w d3,(a6)
   add #4,a6
  dbra d0,forTABAl

   move En,d0
   lea TABEn(PC),a6
   lsr #1,d4
forTABAlE:
   move.w (a6),d3
   cmp d4,d3
   blt ANE
   sub #1,d3
   move.w d3,(a6)
ANE:   
   add #2,a6
  dbra d0,forTABAlE
   bra EndforTEST

UnDMG:
   sub #1,d2
   lsl #8,d2
   add d2,d3
   move.w d3,(a1)
   bra EndforTEST

EndforTEST:
   add #2,a3
   add #2,a2
   add #2,a4
 dbra d7,forTEST

   clr.l d7
   clr.l d0
   clr.l d1
   move.l UnLAT,a4
   move #7,d7
TV:
 move.w (a4),d0
 move.l d0,d1
 lsl #4,d0
 lsr #4,d0
 lsr #8,d0
 cmp #1,d0
 bne TVS
 lsl #8,d1
 lsl #3,d1
 lsr #7,d1
 lsr #8,d1
 cmp #1,d1
 beq VICT
 bne LOOS
VICT:
   bsr ClearScr
   WriteStr #0,#50,#4,victory
   jsr flib::idle_loop
   bra sort

LOOS:
   bsr ClearScr
   WriteStr #0,#50,#4,lose
   jsr flib::idle_loop
   bra sort

TVS: 
 add #2,a4
 dbra d7,TV

      clr.l d0

         SetFont #2
         move.w time,d0
         moveq #3,d1

         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #132,#114,#4,strbuf
         move.w money,d0
         moveq #3,d1

         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #208,#114,#4,strbuf

        clr.l d6
        move ral,d1
        jsr Delay
        add #1,time

        tst.w		tios::kb_globals+$1C	; Une touche a t enfonce ?
        beq		Main
        clr.w	tios::kb_globals+$1C
	   move.w	tios::kb_globals+$1E,d0
        cmp #13,d0
        beq Enter
        cmp #264,d0
        beq sort
                   move #10,mc ; Restore mouse Cursor Shape
        cmp #268,d0
        beq F1	
        cmp #337,d0
        beq left	
        cmp #340,d0
        beq right
        cmp #338,d0
        beq up
        cmp #344,d0
        beq down
        cmp #13,d0
        
                   bra        Main    

Enter:
    cmp #0,select
    bgt POSCHG 
    cmp #0,ms
    beq Main
    cmp #256,ms
    beq BATSEL
    cmp #257,ms
    beq Main
    move #0,select
    move.w ms,d6
    sub #1,d6
    lsl #1,d6
    move.l UnLAT,a3
    add d6,a3
    move.w (a3),d6
    move.l d6,d5
    lsl #8,d5
    lsl #5,d5
    lsr #8,d5
    lsr #5,d5
    
    move #208,d0
    move #32,d1
    move.w d5,d2
    lsl #2,d2
    add #12,d2
    bsr PutSprite   
    move #208,d0
    move #48,d1
    move #61,d2
    bsr PutSprite   
         SetFont #1
    move.l d6,d0
    lsl #4,d0
    lsr #4,d0
    lsr #8,d0
         moveq #2,d1
         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #210,#52,#4,strbuf
    
    cmp #3,d5
    bne EntSui1
    move #3,select
    bra EntSuit
EntSui1:
    move.l d6,d5
    lsl #8,d5
    lsl #3,d5
    lsr #7,d5
    lsr #8,d5
    cmp #1,d5    ; Ennemi ?
    beq Main

EntSui2:    
    move #1,select

EntSuit:    
    move mx,d0
    move my,d1
    lsl #4,d0
    lsl #4,d1
    move.w d1,d5
    move #32,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #33,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #34,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #35,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w ms,curs
    sub #1,curs
    move #35,mc    
    bra Main

POSCHG:
    move #0,select
 move #200,d0 ;200
 move #48,d1  ;48
 move #60,d2
 bsr PutSprite
 move #200,d0
 move #32,d1
 move #60,d2
 bsr PutSprite
 move #216,d0
 move #48,d1
 move #60,d2
 bsr PutSprite
 move #216,d0
 move #32,d1
 move #60,d2
 bsr PutSprite
    
    clr.l d0
    clr.l d6
    move.l UnLAT,a6
    move.l UnDES,a5
    move.l UnPOS,a4
    move.l UnTRA1,a0
    move.l UnTRA2,a1
    move.l UnTRA3,a2

    move.w curs,d6
    lsl #1,d6
    add d6,a6

    move.w (a6),d5 
    move.l d5,d4
    lsl #8,d5
    lsl #4,d5
    lsr #8,d5
    lsr #7,d5
    cmp #1,d5
    bne POSUIT     ;Dplaable ?
    cmp #44,mc
    bne Main
    add d6,a4
    move.w (a4),d0
    move my,d1  
    add mapy,d1
    lsl #8,d1
    add mx,d1    
    add mapx,d1
    jsr TIR
    bra Main
     
POSUIT:    
    move.l d4,d5
    lsl #8,d5
    lsl #5,d5
    lsr #8,d5
    lsr #5,d5
    cmp #3,d5
    bne POSSUIT
    cmp #44,mc
    beq POSSPE
    move.l UnPOS,a4
    add #2,a4
    move.w (a4),d1
    move my,d0       ; Mets la position d'arrive dans UnDES

    add mapy,d0
    lsl #8,d0
    add mx,d0    
    add mapx,d0
    move.l UnPOS,a4
    cmp d0,d1
    beq POSUIT2
    add #4,a4
    move.w (a4),d1
    move.l UnPOS,a4
    cmp d0,d1
    beq POSUIT2
    bne POSSUIT

POSUIT2:
    add #256,d1
    move.w curs,d6
    lsl #1,d6
    add d6,a5
    move.w d1,(a5)
    sub d6,a5
    move.l d4,d5
    lsl #8,d5    
    lsr #8,d5    
    lsr #6,d5
    add #1,my
    cmp #3,d5
    bne POSSUIT    
    sub #1,my
    move.l haddr,a3
    move.w spice,d1
    lsl #2,d1
    lsr #2,d1
    lsr #8,d1
    move.l d1,d0
    lsl #5,d1       
    lsl #2,d0
    add d0,d1
    lsl #1,d1   
    move.w spice,d0
    lsl #2,d0
    lsr #2,d0
    lsl #8,d0
    lsr #7,d0
    add d0,d1
    add d1,a3
    move #256,(a3)

    move.l UnLAT,a5
    move.w curs,d6
    lsl #1,d6
    add d6,a5
    move.w (a5),d5 
    sub #192,d5
    move.w d5,(a5)

    
    add #20,money
    
    move.l UnDES,a5
    move.l UnPOS,a4
    move.l UnTRA1,a0
    move.l UnTRA2,a1
    move.l UnTRA3,a2
    move.l UnLAT,a6
    move.w curs,d6
    lsl #1,d6
    add d6,a6
    add d6,a5
    add d6,a4
    add d6,a0
    add d6,a1
    add d6,a2
    move.w (a4),d6   ; Initialise la trane 
    move.w d6,(a0)
    move.w d6,(a1)
    move.w d6,(a2)
    bra Main

POSSPE:
    move.l UnLAT,a6
    move.w curs,d6
    lsl #1,d6
    add d6,a6
    move.l d4,d5
    lsl #8,d5
    lsl #2,d5
    lsr #8,d5
    lsr #7,d5
    lsl #5,d5
    sub d5,d4
    move #1,d5
    lsl #5,d5
    add d5,d4
    move.w d4,(a6)    

    move my,d0       ; Mets la position d'arrive dans UnDES
    add mapy,d0
    lsl #8,d0
    add mx,d0    
    add mapx,d0
    move.w d0,spice   ;  
    bra POSSUIT2
    

POSSUIT:     
    cmp #44,mc
    bne POSSUIT2
    move.w curs,d6
    lsl #1,d6
    add d6,a4
    move.w (a4),d0
    move my,d1  
    add mapy,d1
    lsl #8,d1
    add mx,d1    
    add mapx,d1
    jsr TIR
    bra Main


POSSUIT2:     
    move.w curs,d6
    lsl #1,d6
    move.l UnDES,a5
    move.l UnPOS,a4
    move.l UnTRA1,a0
    move.l UnTRA2,a1
    move.l UnTRA3,a2
    move.l UnLAT,a6
    add d6,a5
    add d6,a4
    add d6,a0
    add d6,a1
    add d6,a2
    move.w (a4),d6   ; Initialise la trane 
    move.w d6,(a0)
    move.w d6,(a1)
    move.w d6,(a2)
    clr.l d6
    move.w d6,curs

    move my,d0       ; Mets la position d'arrive dans UnDES
    add mapy,d0
    lsl #8,d0
    add mx,d0    
    add mapx,d0
    move.w d0,(a5)   ;  

    move mx,d0
    move my,d1
    lsl #4,d0
    lsl #4,d1
    move.w d1,d5
    move #32,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #33,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #34,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    move.w d5,d1
    move #35,d2
    bsr PutSprite2   
      move #5,d1
    jsr Delay
    bra Main   
 
right:
    move mx,d0
    cmp #11,d0
    beq eright
    add #1,d0
    move d0,mx    
    bra Main
left:
    move mx,d0
    cmp #0,d0
    beq eleft
    sub #1,d0
    move d0,mx    
    bra Main
up:
    move my,d0
    cmp #0,d0
    beq eup
    sub #1,d0
    move d0,my
    bra Main
down:
    move my,d0
    cmp #6,d0
    beq edown
    add #1,d0
    move d0,my
    bra Main

eright:
     move mapx,d0
     cmp #24,d0
     beq Main
     add #1,d0
     move d0,mapx
     bra Main
eleft:
     move mapx,d0
     cmp #0,d0
     beq Main
     sub #1,d0
     move d0,mapx
     bra Main
edown:
     move mapy,d0
     cmp #14,d0
     beq Main
     add #1,d0
     move d0,mapy
     bra Main
eup:
     move mapy,d0
     cmp #0,d0
     beq Main
     sub #1,d0
     move d0,mapy
     bra Main

F1:
        bsr ClearScr
         WriteStr #0,#0,#4,_comment
         WriteStr #0,#24,#4,option1
         WriteStr #0,#34,#4,option2
         WriteStr #0,#44,#4,option3
         WriteStr #0,#54,#4,option4
         WriteStr #0,#64,#4,option5

F1LOOP:
         move.w ral,d0
         moveq #2,d1
         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #190,#34,#4,strbuf
        tst.w		tios::kb_globals+$1C	; Une touche a t enfonce ?
        beq		F1LOOP
        clr.w	tios::kb_globals+$1C
	   move.w	tios::kb_globals+$1E,d0
        cmp #264,d0
        beq F1OPT4
        cmp #268,d0
        blt F1LOOP
        cmp #268,d0
        bne F1OPT2
        tst.b moove
        bne F1OPT12 
        move.b #1,moove
        bsr ClearScr 
        bra Affich
F1OPT12:
        move.b #0,moove
        bsr ClearScr 
        bra Affich

F1OPT2:
        cmp #269,d0
        bne F1OPT3
        jsr flib::idle_loop
        cmp #43,d0
        bne F1OPT22
        sub #1,ral 
        bra F1LOOP
        
F1OPT22:
        cmp #45,d0
        add #1,ral 
        bra F1LOOP
                   
F1OPT3:
        cmp #270,d0
        bne F1OPT4
        tst.w debg
        bne F1OPT32 
        move #1,debg
        bsr ClearScr 
        bra Affich
F1OPT32:
        move #0,debg
        bsr ClearScr 
        bra Affich
        
F1OPT4:
        bsr ClearScr 
        bra Affich


BATSEL:
     move #0,select
     move #0,ms
     cmp #28,UnNB
     bgt Main
        bsr ClearScr
         WriteStr #0,#114,#4,argent
         WriteStr #0,#0,#4,_comment
         WriteStr #0,#24,#4,achete1
         WriteStr #0,#34,#4,achete2
         WriteStr #0,#44,#4,achete3
         WriteStr #0,#54,#4,achete4
         WriteStr #0,#64,#4,achete5
         clr.l d0
         move.w time,d0
         moveq #3,d1
         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #132,#114,#4,strbuf
         move.w money,d0
         moveq #3,d1
         lea	 strbuf(PC),a0
         bsr ConvStr
         WriteStr #208,#114,#4,strbuf
BATLOOP:
        tst.w		tios::kb_globals+$1C	; Une touche a t enfonce ?
        beq		BATLOOP
        clr.w	tios::kb_globals+$1C
	   move.w	tios::kb_globals+$1E,d0
        cmp #264,d0
        beq Affich
        cmp #268,d0
        blt BATLOOP
        cmp #268,d0
        bne BATF2
        cmp #30,money
        blt BATLOOP
        move #1,d4
        bsr BATOC
        lea TABAl(PC),a5
        move.l UnPOS,a2
        move.l UnDES,a3
        move.l UnLAT,a4
        add #1,UnNB
        add #1,Al
        move.w UnNB,d6
        lsl #1,d6
        add #4,a2 ; POS of BATIMENT
        move.w (a2),d3
        add d4,d3
        sub #4,a2
        add d6,a2
        add d6,a3
        add d6,a4
        move.w Al,d6
        lsl #1,d6
        add d6,a5
        move.w d3,(a2)
        move.w UnNB,(a5)
        move.w d3,(a3)
        move.w #2308,(a4)
        sub #30,money        
        bsr ClearScr
        bra Affich

BATF2: 
        cmp #269,d0
        bne BATF3
        cmp #5,money
        blt BATLOOP
        move #1,d4
        bsr BATOC
        lea TABAl(PC),a5
        move.l UnPOS,a2
        move.l UnDES,a3
        move.l UnLAT,a4
        add #1,UnNB
        add #1,Al
        move.w UnNB,d6
        lsl #1,d6
        add #4,a2
        move.w (a2),d3
        add #1,d3
        sub #4,a2
        add d6,a2
        add d6,a3
        add d6,a4
        move.w Al,d6
        lsl #1,d6
        add d6,a5
        move.w d3,(a2)
        move.w UnNB,(a5)
        move.w d3,(a3)
        move.w #1025,(a4)
        sub #5,money        
        bsr ClearScr
        bra Affich

BATF3: 
        cmp #270,d0
        bne BATF4
        cmp #60,money
        blt BATLOOP
        move.w tn,d2
        lsl.w #8,d2         
        lsr.w #8,d2         
        cmp #0,d2
        bne BATF32T
        move #1,d4
        sub #256,d4
        bra BATF3SU
BATF32T: 
        cmp #1,d2
        bne BATF33T
        move #1,d4
        add #512,d4
        bra BATF3SU
BATF33T: 
        cmp #2,d2
        bne BATF34T
        move #1,d4
        add #509,d4
        bra BATF3SU

BATF34T: 
        cmp #3,d2
        bne BATF3SU
        move #1,d4
        sub #259,d4
        bra BATF3SU


BATF3SU:
        bsr BATOC
        lea TABAl(PC),a5
        move.l UnPOS,a2
        move.l UnDES,a3
        move.l UnLAT,a4
        add #1,UnNB
        add #1,Al
        move.w UnNB,d6
        lsl #1,d6
        add #4,a2
        move.w (a2),d3
        add d4,d3

        sub #4,a2
        add d6,a2
        add d6,a3
        add d6,a4
        move.w Al,d6
        lsl #1,d6
        add d6,a5
        move.w d3,(a2)
        move.w UnNB,(a5)
        move.w d3,(a3)
        move.w #2314,(a4)
        sub #60,money        
        add #1,tn
        bsr ClearScr
        bra Affich
BATF4:
        cmp #271,d0
        bne BATF5
        cmp #70,money
        blt BATLOOP
        move #1,d4
        bsr BATOC
        lea TABAl(PC),a5
        move.l UnPOS,a2
        move.l UnDES,a3
        move.l UnLAT,a4
        add #1,UnNB
        add #1,Al
        move.w UnNB,d6
        lsl #1,d6
        add #4,a2
        move.w (a2),d3
        add #1,d3
        sub #4,a2
        add d6,a2
        add d6,a3
        add d6,a4
        move.w Al,d6
        lsl #1,d6
        add d6,a5
        move.w d3,(a2)
        move.w UnNB,(a5)
        move.w d3,(a3)
        move.w #2307,(a4)
        sub #70,money        
        bsr ClearScr
        bra Affich
BATF5: 
        cmp #272,d0
        bne BATF6
        cmp #80,money
        blt BATLOOP
        bsr BATOC
        lea TABAl(PC),a5
        move.l UnPOS,a2
        move.l UnDES,a3
        move.l UnLAT,a4
        add #1,UnNB
        add #1,Al
        move.w UnNB,d6
        lsl #1,d6
        add #4,a2
        move.w (a2),d3
        add #1,d3
        sub #4,a2
        add d6,a2
        add d6,a3
        add d6,a4
        move.w Al,d6
        lsl #1,d6
        add d6,a5
        move.w d3,(a2)
        move.w UnNB,(a5)
        move.w d3,(a3)
        move.w #2304,(a4)
        sub #80,money        
        bsr ClearScr
        bra Affich
BATF6:
        bsr ClearScr
        bra Affich

BATOC:
        move.l d4,d7
        move.l UnPOS,a2
        add #4,a2
        move.w (a2),d3
        add d4,d3
        move.l d3,d0
        lsr #8,d3
        lsl #8,d0
        lsr #8,d0
        jsr Occup
        cmp #1,d2
        beq BATOC2
        move.l d7,d4
        rts
BATOC2:
         WriteStr #0,#84,#4,ocup
         jsr flib::idle_loop
         bsr ClearScr
     bra Affich

TIR:
     move.w mapx,d4
     move.w mapy,d5
     move.l d0,d2
     move.l d1,d3
     lsl #8,d0
     lsr #8,d0
     lsr #8,d2
     lsl #8,d1
     lsr #8,d1
     lsr #8,d3
     sub d2,d3
     muls #4,d3
;     cmp #0,d3
;     bgt Ydifp
;     neg d3

Ydifp: 
     sub d0,d1
     muls #4,d1
;     cmp #0,d1
;     bgt Xdifp
;     neg d1
Xdifp:
   lsl #4,d0
   lsl #4,d2
   lsl #4,d4
   lsl #4,d5
   move #3,d6
forTIR:
     move.w d1,-(a7)
     move.w d3,-(a7)
     move.w d2,-(a7)
     move.w d0,-(a7)
     move.l d5,-(a7)
     move.w #4,d5
     sub d6,d5
     muls d5,d1
     muls d5,d3
     move.l (a7)+,d5

     add d1,d0
     add d3,d2
   cmp d4,d0
   blt EndTIR
   sub #176,d0
   cmp d4,d0
   bgt EndTIR
   add #176,d0
   sub d4,d0
   cmp d5,d2
   blt EndTIR
   sub #96,d2
   cmp d5,d2
   bgt EndTIR
   add #96,d2
   sub d5,d2
     move.l d0,d3
     move.l d2,d1   
     move.l #11,d2
     jsr PutSprite
      move.l #1,d1
     jsr Delay

     move.w (a7)+,d0
     move.w (a7)+,d2
     move.w (a7)+,d3
     move.w (a7)+,d1
     
EndTIR:
   dbra d6,forTIR
   clr.l d1
   clr.l d0
   clr.l d3
   clr.l d2
   clr.l d5
   clr.l d4
   clr.l d6
   rts

sort:
        bsr ClearScr
        jsr gray4lib::off       ; Turn greyscale on
  clr.l d1
  clr.l d0
  clr.l d3
  clr.l d2
  clr.l d5
  clr.l d4
  clr.l d6
  clr.l d7
     move.w         hnbr(PC),-(a7)
     jsr            tios::HeapFree
     lea            2(a7),a7
     rts

ConvStr:
 adda.l  d1,a0
 clr.b	 (a0)
 subq.b  #1,d1
RepConv:
 divu	 #10,d0
 move.l  d0,d2
 lsr.l	 #8,d2
 lsr.l	 #8,d2
 add.b	 #48,d2
 move.b  d2,-(a0)
 and.l	 #$FFFF,d0
 dbra	 d1,RepConv
 rts

PutSprite2:
 movem.l d0-d3/a0-a2,-(a7)
 lea     sprites(PC),a0
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 lea     LCD_MEM,a1
 move.l  greyplane,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFFFFFF,d3
 rol.l   d1,d3
PS_PutRw:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 move.w d2,(a1)
 or.l d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2) 
 or.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRw
 movem.l (a7)+,d0-d3/a0-a2
 rts

PutSprite:
 movem.l d0-d3/a0-a2,-(a7)
 lea     sprites(PC),a0
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 lea     LCD_MEM,a1
 move.l  greyplane,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFF0000,d3
 rol.l   d1,d3
PS_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a1)
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2)
 or.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow
 movem.l (a7)+,d0-d3/a0-a2
 rts

put_grayscale_pixel:
        move.w  d0,d4
        move.w  d1,d5
        lea     LCD_MEM,a0                ;First bitplane
        btst    #1,d3                   ;Test bit 1 in colorvalue to see if
        beq.s   cpix0                  ;we should set or clear this pixel
        bsr     set_pixel
        bra.s   done0
cpix0:
        bsr     clr_pixel
done0:
        move.w  d4,d0
        move.w  d5,d1
        move.l  greyplane(pc),a0           ;Second bitplane
        btst    #0,d3                   ;Test bit 0 in colorvalue to see if
        beq.s   cpix1                  ;we should set or clear this pixel
        bsr     set_pixel
        bra.s   done1
cpix1:
        bsr     clr_pixel
done1:
        rts

clr_pixel:


        bsr     calc_offset
        bclr.b  d2,0(a0,d1)
        rts

set_pixel:
        bsr     calc_offset
        bset.b  d2,0(a0,d1)
        rts

calc_offset:
        add.w   d1,d1   
        move.w  d1,d2 
        lsl.w   #4,d1     
        sub.w   d2,d1  
        move.b  d0,d2
        eor.b   #$7,d2
        lsr.b   #3,d0
        add.w   d0,d1  
        rts

ClearScr:
 movem.l d0/a0-a1,-(a7) 
 move.l  #959,d0  
 move.l  greyplane,a0 
 move.l  #LCD_MEM,a1     
Rep:
 clr.l   (a0)+   
 clr.l   (a1)+   
 dbra    d0,Rep  
 movem.l (a7)+,d0/a0-a1
 rts

Delay:
    jsr Dlay
    dbra d1,Delay
    rts

Dlay:
     move.l	d0,-(a7)
     move.w	#$1800,d0
inplace:
     nop
     dbra d0,inplace
     move.l	(a7)+,d0
     rts

Occup:
            move.l haddr,a6
            move.l d3,d5
            move.l d0,d6
            move.l d3,d4
            lsl #5,d3
            lsl #2,d4
            add d3,d4
            lsl #1,d4  
            lsl #1,d0  
            add d0,d4
            add d4,a6
            move.w (a6),d2 
            move.l haddr,a6
            lsl #7,d2
            lsr #7,d2
            lsr #8,d2
            move.l d5,d3
            move.l d6,d0
            rts

Getdecal:
            move.l haddr,a6
            move.l	d4,-(a7)
            move.l d3,d4
            lsl #5,d3
            lsl #2,d4
            add d3,d4
            lsl #1,d4  
            lsl #1,d0  
            add d0,d4
            add d4,a6
            move.l	(a7)+,d4
            rts

SetBAT:
   move.l haddr,d3
   move.l d5,-(a7)
   cmp.l d3,a6
   blt SetBFN
   add #1512,d3
   cmp.l d3,a6
   bgt SetBFN
   move.w (a6),d2 
   move.l d2,d5
   lsl #7,d2
   lsr #7,d2

   move #1,d3
   lsl #8,d3
   lsl d0,d3
   lsr #8,d3
   lsr #6,d3

   lsr #8,d5
   lsr #6,d5
   cmp d5,d3
   beq SetBTS
   lsl #8,d5
   lsl #6,d5
   add d5,d2
   lsr #8,d5
   lsr #6,d5
   cmp #0,d5
   bne SetBTS 
   move.w d4,d3
   lsl #8,d3
   lsl #1,d3
   add d3,d2
SetBTS:
   move #1,d3
   lsl #8,d3
   lsl d0,d3
   add d3,d2
   move.w d2,(a6) 
SetBFN:
   move.l (a7)+,d5
   rts

SetTAB:
   move.l haddr,d3
   cmp.l d3,a6
   blt SetFNB
   add #1512,d3
   cmp.l d3,a6
   bgt SetFNB
   move.w (a6),d2 
   move.l d2,d3
   lsr #8,d3
   lsr #1,d3
   cmp #0,d3
   beq SetFNB
   lsl #7,d2
   lsr #7,d2
   move.w d2,(a6) 
SetFNB:
   rts

GetNP:
   move.w spice,d5
   move.w d5,d4
   lsr #8,d5
   lsr #6,d5
   lsl #2,d4
   lsr #2,d4
   move #0,d1
DIRECTG:
   cmp #0,d5
   bne DIRECTH
   move #1,d5
   move.l d4,d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   tst.w d0
   beq DIRECTH
   sub #1,d0
   jsr Getdecal
   move.w (a6),d2
   lsl #8,d2
   lsr #8,d2
   add #1,d1
   cmp #4,d1
   bgt DIRECTN
   cmp #1,d2
   bne DIRECTH
   sub #1,d4
   move.w d4,spice
   bra FINNP
    
DIRECTH:
   cmp #1,d5
   bne DIRECTD
   move #2,d5
   move.l d4,d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   tst.w d3
   beq DIRECTD
   sub #1,d3
   jsr Getdecal
   move.w (a6),d2
   lsl #8,d2
   lsr #8,d2
   add #1,d1
   cmp #1,d2
   bne DIRECTD
   sub #256,d4
   add #16384,d4
   move.w d4,spice
   bra FINNP

DIRECTD:
   cmp #2,d5
   bne DIRECTB
   move #3,d5
   move.l d4,d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   cmp #35,d0
   beq DIRECTB
   add #1,d0
   jsr Getdecal
   move.w (a6),d2
   lsl #8,d2
   lsr #8,d2
   add #1,d1
   cmp #1,d2
   bne DIRECTB
   add #1,d4
   add #32768,d4
   move.w d4,spice
   bra FINNP

DIRECTB:
   move #0,d5
   move.l d4,d3
   move.l d3,d0
   lsr #8,d3
   lsl #8,d0
   lsr #8,d0
   cmp #20,d3
   beq DIRECTG
   add #1,d3
   jsr Getdecal
   move.w (a6),d2
   lsl #8,d2
   lsr #8,d2
   add #1,d1
   cmp #1,d2
   bne DIRECTG
   add #256,d4
   add #49152,d4
   move.w d4,spice
   bra FINNP

DIRECTN:
   move.w #0,spice

FINNP:
   rts

MOVEAIU:    ; Input D0.w des pos D2.w n Unit
   move.l a0,-(a7)
   move.l AIPoint,a0   ; Calc relative Position
   lsl #1,d2
   add d2,a0
   move.w (a0),d2
   move.l UnDES,a0
   lsl #1,d2
   add d2,a0
   move.w d0,(a0)
   move.l (a7)+,a0
   rts

CREATAIU:    ; Input D1.w type Unit, D0.w Pos
   move.l a0,-(a7)
   move.l a1,-(a7)
   move.l a2,-(a7)
   move.l UnDES,a1
   move.l UnLAT,a2
   add #1,UnNB
   move.l AIPoint,a0
   move.w AIT,d2
   lsl #1,d2
   add d2,a0
   move.w UnNB,(a0)
   add #1,AIT
   move.l UnPOS,a0
   add #1,En
   move UnNB,d2
   move En,d3
   lsl #1,d2
   lsl #1,d3
   add d2,a0
   add d2,a1
   add d2,a2
   move.w d0,(a0)
   lea TABEn(PC),a0
   add d3,a0
   move.w UnNB,(a0)
   move.w d0,(a1)
   cmp #2,d1
   beq ENTOW
   cmp #6,d1
   beq ENTAN
   cmp #7,d1
   beq ENSOL
   bra CREATEND
ENTOW:
   move.w #2842,(a2) 
   bra CREATEND
ENTAN:
   move.w #2326,(a2) 
   bra CREATEND
ENSOL:
   move.w #1303,(a2) 
   bra CREATEND
   
CREATEND:
   move.l (a7)+,a2
   move.l (a7)+,a1
   move.l (a7)+,a0
   rts

TESTNB:  ; Input d2 nb sufficient Output d2 = 1 success
   cmp En,d2
   bne TESTNBEND
   move #1,d2
TESTNBEND:
   rts

TESTTIME:  ; Input d2 time necessary Output d2 = 1 success
   cmp time,d2
   bne TESTTIMEEND
   move #1,d2
TESTTIMEEND:
   rts

AI:
  move.l POINT,a0
FORAI:
  move.w (a0),d2
  cmp #29809,d2
  beq tantq
  cmp #29801,d2
  beq tim
  cmp #25461,d2
  beq creat
  cmp #28021,d2
  beq mov
  cmp #28277,d2
  beq tesnu
  cmp #15163,d2
  beq tesfin
  cmp #43433,d2
  beq NOmore
  bra tesfin

tantq:
  add #2,a0
  bra FORAI 

tim:
  add #2,a0
  move.w (a0),d2
  sub #2,a0
  move.l d2,d0
  lsr #8,d0
  sub #32,d0
  lsl #8,d2
  lsr #8,d2
  sub #32,d2
  add d0,d2
  jsr TESTTIME
  cmp #1,d2
  bne tfin
  add #4,a0
  bra FORAI 
 
tesnu:
  add #2,a0
  move.w (a0),d2
  sub #2,a0
  lsl #8,d2
  lsr #8,d2
  sub #32,d2
  jsr TESTNB
  cmp #1,d2
  bne tfin
  add #4,a0
  bra FORAI 

creat:
  add #2,a0
  move.w (a0),d0  
  move.l d0,d2
  lsr #8,d0
  sub #32,d0
  lsl #8,d0
  lsl #8,d2
  lsr #8,d2
  sub #32,d2
  add d2,d0
  add #2,a0
  move.w (a0),d1
  lsl #8,d1
  lsr #8,d1
  sub #32,d1
  jsr CREATAIU  
  add #2,a0
  bra FORAI 
  
mov:
  add #2,a0
  move.w (a0),d0  
  move.l d0,d2
  lsr #8,d0
  sub #32,d0
  lsl #8,d0
  lsl #8,d2
  lsr #8,d2
  sub #32,d2
  add d2,d0
  add #2,a0
  move.w (a0),d2
  lsl #8,d2
  lsr #8,d2
  sub #32,d2
  jsr MOVEAIU  
  add #2,a0
  bra FORAI 

tesfin:
  add #2,a0
 
tfin:
  move.l a0,POINT
  bra AIfin

NOmore:
;   bsr ClearScr
;       WriteStr #0,#50,#4,error2
;      jsr flib::idle_loop
;      move.w #1,nomore
;  bra sort

AIfin:
  rts

Done:
      jsr flib::clr_scr
       WriteStr #0,#50,#4,error1
      jsr flib::idle_loop
       rts

;*****************************************************
; Program data
;*****************************************************



strbuf				dc.l 0,0
greyplane    dc.l 0
POINT dc.l 0
UnTRA1 dc.l 0
UnTRA2 dc.l 0
UnTRA3 dc.l 0
UnPOS dc.l 0
UnDES dc.l 0
UnLAT dc.l 0
haddr dc.l 0
AIPoint dc.l 0
sprites  INCBIN sprites.bin
spirit  INCBIN spirit.bin
unit INCBIN unit.bin
AITab INCBIN AITAB.bin
TABEn INCBIN TABEN.bin
TABAl INCBIN TABAL.bin
UnNB dc.w 0
x dc.w 0
i dc.w 0
y dc.w 0
start dc.w 0
mapx  dc.w 0
mapy  dc.w 0
mx dc.w 0
my dc.w 0
mc dc.w 0
ms dc.w 0
hnbr  dc.w 0
select dc.w 0
yp dc.w 0
curs dc.w 0
cur dc.w 0
time dc.w 0
money dc.w 0
ral dc.w 0
spice dc.w 0
tn dc.w 0
debg dc.w 0
Al dc.w 0
En dc.w 0 
AIT dc.w 0

error2  dc.b    " dune4ai.92t is finished!",0
error1  dc.b    " Can't find dune4ai.92t",0
argent  dc.b    " Dune IV   TIME:    MONEY:",0
achete1  dc.b    " Buy TANK  $30  (F1)",0
achete2  dc.b    " Buy SOLDIER  $5  (F2)",0
achete3  dc.b    " Buy ROCKETS TOWER  $60  (F3)",0
achete4  dc.b    " Buy SPICE TAKER  $70  (F4)",0
achete5  dc.b    " Buy Mobil Const Vehi $80 (F5)",0
ocup    dc.b    "EXIT POSITION IS NOT CLEARED !",0
option1  dc.b    " En/Dis able SAND (F1)",0
option2  dc.b    " Change SPEED (F2)",0
option3  dc.b    " En/Dis able Debug (F3)",0
;option3  dc.b    " SAVE (F3)",0
option4  dc.b    " LOAD (F4)",0
filename dc.b "dune4ai",0
victory  dc.b    " VICTORY !",0
lose  dc.b    " MISSION FAILURE !",0
option5  dc.b    " INIT NETWORK -Not Avai- (F5)",0
moove dc.b 0

_comment	dc.b	"Dune IV for TI92",0


;********************** End of Program ************************
	end
